unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, SvcMgr, Dialogs;

type
  TService1 = class(TService)
    procedure ServiceExecute(Sender: TService);
  private
    { Private declarations }
    s:tstringlist;
    procedure threadterminated(sender:tobject);
  public
    function GetServiceController: TServiceController; override;
    { Public declarations }
  end;

var
  Service1: TService1;

procedure log(s:string);

implementation

{$R *.DFM}

uses unit2, SyncObjs;

var cs:TCriticalSection;

procedure log(s:string);
var f:textfile;
begin
  cs.Acquire;
  assignfile(f,'c:\coolservice.log');
  try
    append(f);
  except
    rewrite(f);
  end;
  try// protect the critical section
    writeln(f,s);
  finally
    closefile(f);
  end;
  cs.Release;
end;

procedure ServiceController(CtrlCode: DWord); stdcall;
begin
  Service1.Controller(CtrlCode);
end;

function TService1.GetServiceController: TServiceController;
begin
  Result := ServiceController;
end;

procedure TService1.ServiceExecute(Sender: TService);
var t:array[1..3] of thecoolthread; i,j,k:integer;
begin
  log('starting threads');
  s:=tstringlist.create;
  for i:=1 to 3 do
    t[i]:=thecoolthread.create(nil, threadterminated);
  j:=0;
  while (not terminated) and (j<3) do
  begin
    sleep(100);
    k:=random(10)+1;
    if (k<4) and (t[k]<>nil) then
    begin
      t[k].Terminate;
      t[k]:=nil;
      inc(j);
    end;
  end;
  log('waiting to threads to finish');
  while true do// allow all threads to terminate
  begin
    j:=0;
    sleep(100);
    for i:=1 to 3 do
      if t[i]<>nil then
        inc(j);
    if j=0 then break;
  end;
  log('done');
  s.SaveToFile('c:\thelistfromservice.log');
  s.free;
end;

procedure TService1.threadterminated(sender: tobject);
begin // since this is an event, it does not need to be protected/synchronized as it will run in the main vcl trhead
  log('a thread has terminated');
  s.AddStrings((sender as thecoolthread).text);
end;

initialization
  cs:=TCriticalSection.Create;

finalization
  cs.Free;

end.

