unit Unit2;

interface

uses
  Classes;

type
  TheCoolThread = class(TThread)
  private
    { Private declarations }
    ftext:TStringList;
  protected
    procedure Execute; override;
  public
    property text:TStringList read ftext write ftext;
    constructor create(text:tstrings; event:TNotifyEvent);
    destructor destroy; override;
  end;

implementation

uses sysutils, unit1;

{ Important: Methods and properties of objects in visual components can only be
  used in a method called using Synchronize, for example,

      Synchronize(UpdateCaption);

  and UpdateCaption could look like,

    procedure TheCoolThread.UpdateCaption;
    begin
      Form1.Caption := 'Updated in a thread';
    end; }

{ TheCoolThread }

constructor TheCoolThread.create(text: tstrings; event:TNotifyEvent);
begin
  log('trhead is creating...');
  inherited Create(false);
  FreeOnTerminate:=true;
  OnTerminate:=event;
  ftext:=tstringlist.create;
  if text<>nil then ftext.text:=text.text
               else ftext.Add(inttostr(random(10000)));
  log('thread created');
end;

destructor TheCoolThread.destroy;
begin
  ftext.free;
  inherited;
end;

procedure TheCoolThread.Execute;
begin
  randomize;
  log('thread runs...');
  while not terminated do
  begin
    if random(2)=1 then
      text.add(inttostr(random(500)))
    else
      text.Exchange(random(text.count),random(text.count));
    sleep(random(500));
  end;
  log('thread terminates...');
end;

end.
 